package com.seeyon.apps.timer;

import java.io.*;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.*;

import com.seeyon.apps.collaboration.manager.ColManager;
import com.seeyon.apps.collaboration.po.ColSummary;
import com.seeyon.cap4.form.bean.FormBean;
import com.seeyon.cap4.form.bean.FormDataMasterBean;
import com.seeyon.cap4.form.service.CAP4FormManager;
import com.seeyon.ctp.common.SystemEnvironment;
import com.seeyon.ctp.common.ctpenumnew.manager.EnumManager;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.po.ctpenumnew.CtpEnumItem;
import com.seeyon.ctp.common.po.template.CtpTemplate;
import com.seeyon.ctp.common.template.manager.TemplateManager;
import com.seeyon.ctp.util.Strings;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

@Component
public class FalseDoTimer {

    private ColManager colManager;
    private TemplateManager templateManager;
    private CAP4FormManager cap4FormManager;
    private EnumManager enumManagerNew;

    public ColManager getColManager() {
        return colManager;
    }

    public void setColManager(ColManager colManager) {
        this.colManager = colManager;
    }

    public TemplateManager getTemplateManager() {
        return templateManager;
    }

    public void setTemplateManager(TemplateManager templateManager) {
        this.templateManager = templateManager;
    }

    public CAP4FormManager getCap4FormManager() {
        return cap4FormManager;
    }

    public void setCap4FormManager(CAP4FormManager cap4FormManager) {
        this.cap4FormManager = cap4FormManager;
    }

    public EnumManager getEnumManagerNew() {
        return enumManagerNew;
    }

    public void setEnumManagerNew(EnumManager enumManagerNew) {
        this.enumManagerNew = enumManagerNew;
    }

    /**
     * 修改门户状态失败定时器
     * @param
     * @return
     * @throws Exception
     * @author
     */
    public void FalseDo() throws Exception {
        Timer timer = new Timer();
        timer.schedule(new TimerTask() {
            public void run() {
                //System.out.println("定时器启动");
                RestTemplate restTemplate = new RestTemplate();
                ColSummary summary = null;
                List<ColSummary> data = null;
                Map<String, Object> respnose=new HashMap<>();
                try {
                    List<Integer> genneral = new ArrayList<>();
                    genneral.add(5);
                    genneral.add(6);
                    data = colManager.getFalseData(genneral);
                    for (ColSummary coldata : data) {

                        String code = coldata.getSource();
                        Integer oastate = coldata.getGeneralState();
                        Long templateId = coldata.getTempleteId();
                        CtpTemplate ctpTemplate = null;
                        ctpTemplate = templateManager.getCtpTemplate(templateId);

                        //校稿流程
                        if ("JGLC".equals(ctpTemplate.getTempleteNumber())) {
                            if (oastate == 5) {
                                String filePath = SystemEnvironment.getApplicationFolder() + File.separator + "fkmap" + File.separator + "url.properties" ;
                                InputStream in = new BufferedInputStream(new FileInputStream(filePath));
                                Properties p = new Properties();
                                p.load(in);
                                String url = p.getProperty("menhu");
                                String DIC_DATA_URL = url + "/getWaitHand/oaSetStatus";
                                DIC_DATA_URL = DIC_DATA_URL + "?id=" + code + "&oaStatus=0";
                                respnose = restTemplate.postForObject(DIC_DATA_URL, null, Map.class);
                                String succ=respnose.get("success").toString();
                                if (Strings.isNotBlank(succ)&&"true".equals(succ)) {
                                    colManager.updateColSummaryGeneralStateBySource(code, 0);
                                }



                            } else if (oastate == 6) {   //终止流程
                                String filePath = SystemEnvironment.getApplicationFolder() + File.separator + "fkmap" + File.separator + "url.properties" ;
                                InputStream in = new BufferedInputStream(new FileInputStream(filePath));
                                Properties p = new Properties();
                                p.load(in);
                                String url = p.getProperty("menhu");
                                String DIC_DATA_URL = url + "/getWaitHand/oaSetStatus";
                                DIC_DATA_URL = DIC_DATA_URL + "?id=" + code + "&oaStatus=1";
                                respnose = restTemplate.postForObject(DIC_DATA_URL, null, Map.class);
                                String succ=respnose.get("success").toString();
                                if (Strings.isNotBlank(succ)&&"true".equals(succ)) {
                                    colManager.updateColSummaryGeneralStateBySource(code, 0);
                                }
                            }



                            //下单流程
                        } else if ("XDLC".equals(ctpTemplate.getTempleteNumber()) | "ECXDLC".equals(ctpTemplate.getTempleteNumber())
                        | "XDLCQT".equals(ctpTemplate.getTempleteNumber()) | "ECXDLCQT".equals(ctpTemplate.getTempleteNumber())) {
                            if (oastate == 4) {     //审核通过
                                String filePath = SystemEnvironment.getApplicationFolder() + File.separator + "fkmap" + File.separator + "url.properties" ;
                                InputStream in = new BufferedInputStream(new FileInputStream(filePath));
                                Properties p = new Properties();
                                p.load(in);
                                String url = p.getProperty("menhu");
                                String DIC_DATA_URL = url + "/getWaitHand/oaUpdateData";
                                // 调用外部接口，修改门户订单状态，并将最终审核后的数据提交给OA，此时相关填写数据已修改
                                Long formappid = coldata.getFormAppid();
                                Long formrecordid = coldata.getFormRecordid();
                                FormBean formBean = cap4FormManager.getForm(formappid, false);
                                FormDataMasterBean master = null;
                                try {
                                    master = cap4FormManager.getDataMasterBeanById(formrecordid, formBean, null);
                                } catch (SQLException e) {
                                    e.printStackTrace();
                                }

                                CtpEnumItem ctpEnumItem;

                                String namekeydistribution = master.getFormTable().getFieldMap4Display().get("配送方式").getName();
                                String distribution = (String) master.getAllDataMap().get(namekeydistribution);
                                String distribution1 = null;
                                if (StringUtils.isNotBlank(distribution)) {
                                    ctpEnumItem = enumManagerNew.getEnumItem(Long.valueOf(distribution));
                                    distribution1 = ctpEnumItem.getShowvalue();
                                }

                                String namekeyurgent = master.getFormTable().getFieldMap4Display().get("加急").getName();
                                String  urgent = (String)master.getAllDataMap().get(namekeyurgent);
                                String urgent1 = null;
                                if (StringUtils.isNotBlank(urgent)) {
                                    ctpEnumItem = enumManagerNew.getEnumItem(Long.valueOf(urgent));
                                    urgent1 = ctpEnumItem.getEnumvalue();
                                }


                                String namekeytotalprice = master.getFormTable().getFieldMap4Display().get("总价").getName();
                                BigDecimal totalprice = (BigDecimal) master.getAllDataMap().get(namekeytotalprice);

                                String namekeyunitprice = master.getFormTable().getFieldMap4Display().get("单价").getName();
                                BigDecimal unitprice = (BigDecimal) master.getAllDataMap().get(namekeyunitprice);


                                if("XDLC".equals(ctpTemplate.getTempleteNumber()) || "ECXDLC".equals(ctpTemplate.getTempleteNumber())) {
                                    String namekeypageSize = master.getFormTable().getFieldMap4Display().get("开型").getName();
                                    String pageSize = (String) master.getAllDataMap().get(namekeypageSize);
                                    String pageSize1 = null;
                                    if (StringUtils.isNotBlank(pageSize)) {
                                        ctpEnumItem = enumManagerNew.getEnumItem(Long.valueOf(pageSize));
                                        pageSize1 = ctpEnumItem.getShowvalue();
                                    }

                                    String namekeycover = master.getFormTable().getFieldMap4Display().get("亮膜").getName();
                                    String cover = (String) master.getAllDataMap().get(namekeycover);
                                    String namekeycover1 = master.getFormTable().getFieldMap4Display().get("哑膜").getName();
                                    String cover1 = (String) master.getAllDataMap().get(namekeycover1);
                                    String namekeycover2 = master.getFormTable().getFieldMap4Display().get("烫金").getName();
                                    String cover2 = (String) master.getAllDataMap().get(namekeycover2);
                                    String namekeycover3 = master.getFormTable().getFieldMap4Display().get("UV").getName();
                                    String cover3 = (String) master.getAllDataMap().get(namekeycover3);
                                    String covers = "";
                                    if (cover.equals("1"))
                                        covers += "亮膜,";
                                    if (cover1.equals("1"))
                                        covers += "哑膜,";
                                    if (cover2.equals("1"))
                                        covers += "烫金,";
                                    if (cover3.equals("1"))
                                        covers += "UV,";
                                    if (covers.length() > 0)
                                        covers = covers.substring(0, covers.length() - 1);

                                    String namekeycoverSize = master.getFormTable().getFieldMap4Display().get("封面纸张").getName();
                                    String coverSize = (String) master.getAllDataMap().get(namekeycoverSize);
                                    String coverSize1 = null;
                                    if (StringUtils.isNotBlank(coverSize)) {
                                        ctpEnumItem = enumManagerNew.getEnumItem(Long.valueOf(coverSize));
                                        coverSize1 = ctpEnumItem.getShowvalue();
                                    }

                                    String namekeynevinSize = master.getFormTable().getFieldMap4Display().get("内页纸张").getName();
                                    String nevinSize = (String) master.getAllDataMap().get(namekeynevinSize);
                                    String nevinSize1 = null;
                                    if (StringUtils.isNotBlank(nevinSize)) {
                                        ctpEnumItem = enumManagerNew.getEnumItem(Long.valueOf(nevinSize));
                                        nevinSize1 = ctpEnumItem.getShowvalue();
                                    }

                                    String namekeynevinColor = master.getFormTable().getFieldMap4Display().get("内页颜色").getName();
                                    String neivinColor = (String) master.getAllDataMap().get(namekeynevinColor);
                                    String neivinColor1 = null;
                                    if (StringUtils.isNotBlank(neivinColor)) {
                                        ctpEnumItem = enumManagerNew.getEnumItem(Long.valueOf(neivinColor));
                                        neivinColor1 = ctpEnumItem.getShowvalue();
                                    }

                                    String namekeyinsertSize = master.getFormTable().getFieldMap4Display().get("插页纸张").getName();
                                    String insertSize = (String) master.getAllDataMap().get(namekeyinsertSize);
                                    String insertSize1 = null;
                                    if (StringUtils.isNotBlank(insertSize)) {
                                        ctpEnumItem = enumManagerNew.getEnumItem(Long.valueOf(insertSize));
                                        insertSize1 = ctpEnumItem.getShowvalue();
                                    }

                                    String namekeymachinetype = master.getFormTable().getFieldMap4Display().get("装订方式").getName();
                                    String machinetype = (String) master.getAllDataMap().get(namekeymachinetype);
                                    String machinetype1 = null;
                                    if (StringUtils.isNotBlank(machinetype)) {
                                        ctpEnumItem = enumManagerNew.getEnumItem(Long.valueOf(machinetype));
                                        machinetype1 = ctpEnumItem.getShowvalue();
                                    }


                                    String namekeypagesided = master.getFormTable().getFieldMap4Display().get("单双面").getName();
                                    String pagesided = (String) master.getAllDataMap().get(namekeypagesided);
                                    String pagesided1 = null;
                                    if (StringUtils.isNotBlank(pagesided)) {
                                        ctpEnumItem = enumManagerNew.getEnumItem(Long.valueOf(pagesided));
                                        pagesided1 = ctpEnumItem.getShowvalue();
                                    }
                                    String remark = master.getFormTable().getFieldMap4Display().get("备注").getName();
                                    String remarks = (String) master.getAllDataMap().get(remark);
                                    if ("ECXDLC".equals(ctpTemplate.getTempleteNumber())) {
                                        String namekeyyhprice = master.getFormTable().getFieldMap4Display().get("优惠价").getName();
                                        totalprice = (BigDecimal) master.getAllDataMap().get(namekeyyhprice);
                                    }

                                    DIC_DATA_URL = DIC_DATA_URL+"?id="+code+"&printStatus="+1+"&pageSize="+pageSize1+"&cover="+covers+"&coverSize="+coverSize1+"&nevinSize="+nevinSize1+"&insertSize="+insertSize1+"&machinetype="+machinetype1+"&distribution="+distribution1+"&pagesided="+pagesided1+"&urgent="+urgent1+"&aggregate="+totalprice+"&price="+unitprice+"&remark="+remarks+"&neivinColor="+neivinColor1;
                                }else {
                                    if ("ECXDLCQT".equals(ctpTemplate.getTempleteNumber())){
                                        String namekeyyhprice = master.getFormTable().getFieldMap4Display().get("优惠价").getName();
                                        totalprice = (BigDecimal)master.getAllDataMap().get(namekeyyhprice);
                                    }

                                    String remark = master.getFormTable().getFieldMap4Display().get("客户备注").getName();
                                    String remarks = (String)master.getAllDataMap().get(remark);
                                    DIC_DATA_URL = DIC_DATA_URL+"?id="+code+"&printStatus="+1+"&urgent="+urgent1+"&aggregate="+totalprice+"&price="+unitprice+"&remark="+remarks+"&distribution="+distribution1;
                                }


//                                DIC_DATA_URL = DIC_DATA_URL + "?id=" + code + "&printStatus=" + 1 + "&pageSize=" + pageSize1 + "&cover=" + cover1 + "&coverSize=" + coverSize1 + "&nevinSize=" + nevinSize1 + "&insertSize=" + insertSize1 + "&machinetype=" + machinetype1 + "&distribution=" + distribution1 + "&pagesided=" + pagesided1 + "&urgent=" + urgent + "&aggregate=" + totalprice + "&price=" + unitprice + "&remark=" + remarks;
                                respnose = restTemplate.postForObject(DIC_DATA_URL, null, Map.class);
                                String succ=respnose.get("success").toString();
                                if (Strings.isNotBlank(succ)&&"true".equals(succ)) {
                                    colManager.updateColSummaryGeneralStateBySource(code, 0);
                                }



                            } else if (oastate == 5) {     //终止流程
                                String filePath = SystemEnvironment.getApplicationFolder() + File.separator + "fkmap" + File.separator + "url.properties" ;
                                InputStream in = new BufferedInputStream(new FileInputStream(filePath));
                                Properties p = new Properties();
                                p.load(in);
                                String url = p.getProperty("menhu");
                                String DIC_DATA_URL = url + "/signprintmessage/oaSetPrintStatus";
                                DIC_DATA_URL = DIC_DATA_URL + "?printId=" + code + "&printStatus=2";
                                respnose = restTemplate.postForObject(DIC_DATA_URL, null, Map.class);
                                String succ=respnose.get("success").toString();
                                if (Strings.isNotBlank(succ)&&"true".equals(succ)) {
                                    colManager.updateColSummaryGeneralStateBySource(code, 0);
                                }
                            }
                        }
                    }
                } catch (BusinessException | IOException e) {
                    e.printStackTrace();
                }
            }

        }, 5000, 60000);
    }
}
